
Imports System
Imports System.IO
'Imports System.Collections
'Imports System.Web
'Imports System.Web.UI
'Imports System.Web.UI.WebControls
'Imports System.Web.UI.HtmlControls
'Imports Microsoft.VisualBasic

Partial Class ArchivosForm : Inherits Page

#Region " Código generado por el Diseñador de Web Forms "

    'El Diseñador de Web Forms requiere esta llamada.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents bt2 As System.Web.UI.WebControls.Button
    Protected WithEvents lista As System.Web.UI.WebControls.DropDownList
    Protected WithEvents total As System.Web.UI.WebControls.Label

    'NOTA: el Diseñador de Web Forms necesita la siguiente declaración del marcador de posición.
    'No se debe eliminar o mover.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: el Diseñador de Web Forms requiere esta llamada de método
        'No la modifique con el editor de código.
        InitializeComponent()
    End Sub

#End Region

    'variables a nivel de clase
    Protected ruta, ruta2 As String
    Protected i, j As Integer

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'configurar el título del documento HTML en tiempo de ejecución
        Response.Write("<HEAD><TITLE>Listado de archivos</TITLE></HEAD>")
        'ruta por defecto al cargar la página
        'cuando aún no ha tenido lugar ningún evento TextChanged del TextBox
        'ruta2 = "C:\Windows"
        'ruta = "C:\Windows"
    End Sub

    'cuando cambia el texto escrito en el TextBox
    Sub Texto_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles texto.TextChanged
        Try
            'ruta2 se asigna al ítem elegido
            ruta2 = texto.Text
            'la ruta se construye de manera diferente si se usa:
            ' - AppDomain.CurrentDomain.BaseDirectory que nos da la ruta física que se corresponde 
            'con la ruta virtual de la aplicación ASP NET
            ' - una cadena simple como ruta física a un directorio del disco duro
            'En las rutas virtuales del servidor web se usa Server.MapPath y se le pasa como parámetro la cadena ruta2
            If ruta2.StartsWith("/") Or ruta2.Contains("/") Then
                ruta = Server.MapPath(ruta2)
                'ruta = AppDomain.CurrentDomain.BaseDirectory & ruta2
                Response.Write("<div align=center style='font-family:verdana; font-size:10px; color: darkred'>")
                'Response.Write("Server.MapPath(ruta2): " & Server.MapPath(ruta2))
                Response.Write("<br>BaseDirectory: " & AppDomain.CurrentDomain.BaseDirectory.ToString)
                Response.Write("<br>Ruta seleccionada: " & ruta2 & "</div>")
            Else
                'en los demás casos (rutas reales al disco duro o cadena vacía) se igualan ruta y ruta2
                ruta = ruta2
            End If
        Catch Pollo As Exception
            Response.Write("<h2 align=center style='font-family:verdana;'>Listar archivos de un directorio</h2>")
            Response.Write("<p align=center style='font-family:verdana; font-size:10pt; color:red;'><b>" &
Pollo.Message & "</b></p>")
            Response.End() 'detiene la carga de la página
        End Try
    End Sub

    ' --- LISTAR ARCHIVOS USANDO SYSTEM.COLLECTIONS.IENUMERATOR ---

    'COLECCIONES - INTERFAZ IENUMERATOR
    'Una colección (Collection) es un tipo especial de matriz
    'especialmente preparado para unas tareas determinadas
    'Los objetos Collection se crean desde las clases e interfaces
    'del espacio de nombres System.Collections
    'Interfaces de Collections:
    ' - IEnumerator: recorrer listas de valores
    ' - IList: ordenar listas de valores
    ' - ICollection: modificar listas de valores
    ' - ICloneable: hacer copias de listas de valores
    'IEnumerator admite una iteración simple a través de una colección
    'El método GetEnumerator devuelve un enumerador que puede iterar por una colección
    'IEnumerator es la interfaz base de todos los enumeradores
    'Los enumeradores sólo permiten la lectura de datos de la colección
    'Los enumeradores no se pueden utilizar para modificar la colección
    'Inicialmente, el enumerador se coloca delante del primer elemento de la colección
    'Reset también devuelve el enumerador a esta posición
    'MoveNext desplaza el enumerador al primer elemento antes de leer el valor de Current.
    'Current devuelve el mismo objeto hasta que se llama a MoveNext o a Reset
    'MoveNext establece Current en el siguiente elemento
    'Alcanzado el final, el enumerador se coloca después del último elemento
    'El enumerador no tiene acceso exclusivo a la colección (no proporciona gran seguridad)

    Sub Listar1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt3.Click
        Try
            Response.Write("<h2 align=center style='font-family:verdana;'>Listar archivos de un directorio</h2>")
            'array de cadenas para contener los nombres de los archivos del directorio
            Dim lista1() As String
            lista1 = System.IO.Directory.GetFiles(ruta)
            'objeto IEnumerator que permitirá recorrer la lista de archivos
            Dim lista2 As System.Collections.IEnumerator
            'lista2 se forma desde el método GetEnumerator de lista1
            'GetEnumerator construye un objeto enumerador que contiene:
            ' -  el número de versión de la colección
            ' - una referencia a los elementos de la colección
            lista2 = lista1.GetEnumerator
            'i: entero para contener el número de archivos del directorio
            'j: entero para contener la longitud de la cadena ruta
            i = lista1.Length
            j = ruta.Length
            'crear la tabla en cuyas celdas aparece la información
            'se usan estilos CSS para dar formato a las celdas
            Response.Write("<table align=center border=0'>")
            Response.Write("<tr style='font-family:verdana; font-size:10pt; font-weight:bold; text-align:center;background-color:black; color:white;'><td>")
            'cabecera de la tabla con el nombre del directorio
            Response.Write("<b>Directorio: " & ruta2 & "</b>")
            Response.Write("</td></tr>")
            Response.Write("<tr style='font-family:verdana; font-size:10pt; text-align:center;background-color:blue; color:white;'><td>")
            'fila con el número de archivos del directorio
            Response.Write("Número de archivos: <b>" & i & "</b>")
            Response.Write("</td></tr>")
            'se van leyendo los elementos de la colección hasta el final de la misma
            While lista2.MoveNext
                Response.Write("<tr style='font-family:verdana; font-size:10pt; text-align:left;background-color:Gainsboro; color:black;'><td>")
                'lista.Current devuelve el nombre largo de archivo (con ruta incluida)
                'para dejar sólo el nombre corto de archivo (sin la ruta):
                ' - si la variable ruta termina en \ se quita de lista.Current la longitud de la variable
                '(ruta termina en \ si se forma con ServerMapPath (ej: ruta = Server.MapPath("/img"))
                ' - si la variable ruta NO termina en \ se quita de lista.Current la longitud de la variable más 1 carácter
                '(ruta NO termina en \ si se forma con la ruta como cadena sencilla (ej: ruta="C:\Windows")
                If ruta.EndsWith("\") Then
                    Response.Write(CStr(lista2.Current).Remove(0, (j)))
                Else
                    Response.Write(CStr(lista2.Current).Remove(0, (j + 1)))
                End If
                Response.Write("</tr></td>")
            End While
            Response.Write("</table>")
        Catch pollo As Exception
            If texto.Text.Length = 0 Then
                Response.Write("<p align=center style='font-family:verdana; font-size:10pt; color:red;'><b>" &
                           "No se ha definido la ruta a los archivos que se van a listar.</b></p>")
            Else
                Response.Write("<p align=center style='font-family:verdana; font-size:10pt; color:red;'><b>" &
                pollo.Message & "</b></p>")
            End If
            Response.End() 'detiene la carga de la página
        End Try
        Response.End() 'detiene la carga de la página
    End Sub

    ' --- LISTAR ARCHIVOS USANDO SYSTEM.IO (FILEINFO Y DIRECTORYINFO) ---

    'MANEJO DE ARCHIVOS CON SYSTEM.IO
    'El espacio de nombres System.IO contiene clases que facilitan
    'el trabajo con archivos y carpetas:
    ' - File y Directory: contienen métodos estáticos. Los miembros de File y de
    'Directory son miembros compartidos por lo que es más sencillo su uso pues no es
    'necesario crear una instancia previa de su clase; sirven para crear, borrar y modificar
    'archivos y carpetas: Exists, Copy, Move, Delete, OpenText, GetAttributes, 
    ' - FileInfo y DirectoryInfo: contienen métodos de instancia. por lo que es necesario
    'crear un objeto para poder utilizar la clase; sus métodos sirven para extraer
    'información de los aributos de archivos y carpetas: Name, FullName, CreationTime, etc...
    ' - Path: contiene métodos para administrar cadenas DirectoryInfo/archivo

    'listar los archivos de un directorio sin entrar en los directorios
    Sub Listar2(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim archivo As String 'para el nombre de archivo
        Dim sArchivos() As String 'array con los nombres de archivos
        Dim archivoInfo As FileInfo 'objeto para extraer propiedades de los archivos
        Try
            'el objeto Response permite interaccionar servidor con cliente,
            'su método Write envía resultados HTTP al navegador web cliente.
            'Aquí lo utilizamos para ir enviando código HTML que va formateando una tabla
            'cuyas celdas se irán rellenando con texto y resultados de la ejecución de código VB
            Response.Write("<h2 align=center style='font-family:verdana;'>Listar archivos de un directorio</h2>")
            'array de cadenas con los nombres de archivo en el directorio actual
            sArchivos = Directory.GetFiles(ruta)
            'número de archivos en el directorio
            i = sArchivos.Length
            'crear la tabla y la cabecera con formato basado en estilos CSS
            Response.Write("<table align=center border=0 style='font-family:verdana; font-size:10pt;'>")
            Response.Write("<tr><td colspan=4 align=center style='background-color:black; color:white;'>")
            Response.Write("<b>Directorio: " & ruta2 & "</b>")
            Response.Write("</td></tr>")
            Response.Write("<tr style='font-family:verdana; font-size:10pt; text-align:center;background-color:blue; color:white;'><td>")
            'fila con el número de archivos del directorio
            Response.Write("Número de archivos: <b>" & i & "</b>")
            Response.Write("</td></tr>")
            'obtener lista de archivos contenidos en el directorio actual
            For Each archivo In sArchivos
                archivoInfo = New FileInfo(archivo)
                Response.Write("<tr>")
                Response.Write("<td bgcolor=Gainsboro>" & archivoInfo.Name & "</td>")
            Next
            Response.Write("</td></tr>")
            Response.Write("</table>")
        Catch pollo As Exception
            If texto.Text.Length = 0 Then
                Response.Write("<p align=center style='font-family:verdana; font-size:10pt; color:red;'><b>" &
                           "No se ha definido la ruta a los archivos que se van a listar.</b></p>")
            Else
                Response.Write("<p align=center style='font-family:verdana; font-size:10pt; color:red;'><b>" &
                pollo.Message & "</b></p>")
            End If
            Response.End() 'detiene la carga de la página
        End Try
        Response.End() 'detiene la carga de la página
    End Sub


    'listar los archivos de un directorio y del primer subnivel de directorios
    Sub Listar3(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim archivo, carpeta As String 'para el nombre de archivos y carpetas
        Dim sArchivos(), sCarpetas() As String 'array con los nombres de archivos y carpetas
        Dim carpetaInfo As DirectoryInfo 'objeto para extraer propiedades de las carpetas
        Dim archivoInfo As FileInfo 'objeto para extraer propiedades de los archivos
        Try
            'el objeto Response permite interaccionar servidor con cliente,
            'su método Write envía resultados HTTP al navegador web cliente.
            'Aquí lo utilizamos para ir enviando código HTML que va formateando una tabla
            'cuyas celdas se irán rellenando con texto y resultados de la ejecución de código VB
            Response.Write("<h2 align=center style='font-family:verdana;'>Listar archivos de un directorio</h2>")
            'array con los nombres de archivo en el directorio actual
            sArchivos = Directory.GetFiles(ruta)
            sCarpetas = Directory.GetDirectories(ruta)
            'número de archivos en el directorio
            i = sArchivos.Length
            'crear la tabla y la cabecera con títulos de columnas
            Response.Write("<table align=center border=0 style='font-family:verdana; font-size:10pt;'>")
            Response.Write("<tr style='background-color:black; color:white; font-weight:bold;'>")
            Response.Write("<td>Nombre</td>")
            Response.Write("<td align=right>Tamaño</td>")
            Response.Write("<td align=center>Fecha</td>")
            Response.Write("<td align=center>Hora</td></tr>")
            'sección que lista los archivos que cuelgan directamente del directorio actual
            'condiciones: listar sólo en carpetas con al menos 1 archivo
            If i > 0 Then
                Response.Write("<tr><td colspan=4 align=center style='background-color:gray; color:white;'>")
                Response.Write("<b>Directorio " & ruta2 & " [archivos: " & i & "</b>]")
            End If
            Response.Write("</td></tr>")

            'Obtener lista de archivos contenidos en el directorio actual
            For Each archivo In sArchivos
                archivoInfo = New FileInfo(archivo)
                Response.Write("<tr>")
                Response.Write("<td bgcolor=Gainsboro>" & archivoInfo.Name & "</td>")
                Response.Write("<td bgcolor=Gainsboro align=right>" & archivoInfo.Length.ToString("#,#") & " bytes</td>")
                Response.Write("<td bgcolor=Gainsboro align=center>" & archivoInfo.CreationTime.ToShortDateString & "</td>")
                Response.Write("<td bgcolor=Gainsboro align=center>" & archivoInfo.CreationTime.ToLongTimeString & "</td></tr>")
            Next

            'Obtener lista de directorios del directorio actual 
            For Each carpeta In sCarpetas
                'For Each carpeta In Directory.GetDirectories(ruta)
                carpetaInfo = New DirectoryInfo(carpeta)
                'array con nombres de archivos en cada directorio
                sArchivos = Directory.GetFiles(carpeta)
                'número de carpetas en el directorio
                j = sArchivos.Length
                'sección que lista las carpetas que cuelgan directamente del directorio
                'condición: listar sólo en carpetas con al menos 1 archivo
                'If j > 0 Then
                Response.Write("<tr><td colspan=4 align=center style='background-color:gray; color:white;'>")
                'condición: ocultar algunos directorios que no queremos que aparezcan en la lista
                'If carpetaInfo.Name <> "nombre_de_carpeta_para_ocultar" Then
                If ruta2 = "/" Then
                    Response.Write("<b>Directorio " & ruta2 & carpetaInfo.Name & " [archivos: " & j & "</b>]")
                ElseIf ruta2.StartsWith("C:\") Then
                    Response.Write("<b>Directorio " & ruta2 & "\" & carpetaInfo.Name & " [archivos: " & j & "</b>]")
                Else
                    Response.Write("<b>Directorio " & ruta2 & "/" & carpetaInfo.Name & " [archivos: " & j & "</b>]")
                End If
                'End If
                'End If
                Response.Write("</td></tr>")
                'calcular el número total de archivos que hay en los directorios
                i += j
                'obtener lista de archivos contenidos en los directorios de primer nivel
                'sección que lista los archivos de esos directorios
                For Each archivo In Directory.GetFiles(carpeta)
                    archivoInfo = New FileInfo(archivo)
                    Response.Write("<tr bgcolor=Gainsboro><td>/" & carpetaInfo.Name & "/" & archivoInfo.Name & "</td>")
                    Response.Write("<td bgcolor=Gainsboro align=right>" & archivoInfo.Length.ToString("#,#") & " bytes</td>")
                    Response.Write("<td bgcolor=Gainsboro>" & archivoInfo.CreationTime.ToShortDateString & "</td>")
                    Response.Write("<td bgcolor=Gainsboro>" & archivoInfo.CreationTime.ToLongTimeString & "</td></tr>")
                Next
            Next

        Catch pollo As Exception
            ''finalizar la tabla con el Nº total de archivos listados
            ''sólo si el TextBox contiene alguna ruta
            'If ruta2 <> "" Then
            '    Response.Write("<tr><td colspan=4 align=center style='background-color:blue; color:white;'>")
            '    Response.Write("<b>Número total de archivos = " & i & "</b>")
            '    Response.Write("</td></tr>")
            'End If
            Response.Write("</table>")
            If texto.Text.Length = 0 Then
                Response.Write("<p align=center style='font-family:verdana; font-size:10pt; color:red;'><b>" &
                           "No se ha definido la ruta a los archivos que se van a listar.</b></p>")
            Else
                Response.Write("<p align=center style='font-family:verdana; font-size:10pt; color:red;'><b>" &
                pollo.Message & "</b></p>")
            End If
            Response.End() 'detiene la carga de la página
        End Try
        'finalizar la tabla con el Nº total de archivos listados
        Response.Write("<tr><td colspan=4 align=center style='background-color:blue; color:white;'>")
        Response.Write("<b>Número total de archivos = " & i & "</b>")
        Response.Write("</td></tr>")
        Response.Write("</table>")
        Response.End() 'detiene la carga de la página
    End Sub

    'descargar el archivo zip con la aplicación completa
    Sub Zip(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt5.Click, bt5.Click, bt5.Click, bt5.Click
        Response.Redirect("archivos.zip", True)
    End Sub

End Class
